/****************************************************************************
*
*   Copyright (c) 2008 www.societyofrobots.com
*   (please link back if you use this code!)
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License version 2 as
*   published by the Free Software Foundation.
*
*   Alternatively, this software may be distributed under the terms of BSD
*   license.
*
****************************************************************************/

//SoR Include
#include "SoR_Utils.h" //includes all the technical stuff
#include "hardware.c" //declare hardware variables and ports
//#include "CMUcam.c" //not yet written
#include "sensors.c" //not yet written, sensor libraries for sonar, sharp IR, etc.
//#include "Blackfin_Axon.c" //files for Blackfin Robot camera
#include "control.c" //your code goes in here
//#include "axon_test.c" //include this is doing a function test for the Axon
//#include "axon_oscope_test.c" //include this is doing a function test for the Axon


int main(void)
	{
	//declare variables here
	int i=0;//useless variable
	int j=0;//useless variable


	/****************INITIALIZATIONS*******************/
	//other stuff Im experimenting with for SoR
	uartInit();  // initialize the UART (serial port)
    uartSetBaudRate(0, 38400); // set UARTE speed, for Bluetooth
    uartSetBaudRate(1, 115200); // set UARTD speed, for USB connection
    uartSetBaudRate(2, 38400); // set UARTH speed
    uartSetBaudRate(3, 38400); // set UARTJ speed, for Blackfin
	//G=Ground, T=Tx (connect to external Rx), R=Rx (connect to external Tx)

	rprintfInit(uart1SendByte);// initialize rprintf system and configure uart1 (USB) for rprintf

	timer0Init(); // initialize the timer system
	timer2Init(); // initialize the timer system
	
	configure_ports(); // configure which ports are analog, digital, etc.

	a2dInit(); // initialize analog to digital converter (ADC)
	a2dSetPrescaler(ADC_PRESCALE_DIV32); // configure ADC scaling
	a2dSetReference(ADC_REFERENCE_AVCC); // configure ADC reference voltage

	LED_on();

	rprintf("\r\nSystem Warming Up");

	//let system stabelize for X time
	for(i=0;i<=16;i++)
		{
		delay_cycles(5000);
		rprintf(".");
		}

	delay_cycles(6000);

	//read each ADC once to get it working accurately
	for(i=0;i<16;i++)
		j=a2dConvert8bit(i);

	LED_off();
	/**************************************************/

//test programs
//while(1)
//{
//test_oscope();
//test();
//}
	
	/*********ADD YOUR CODE BELOW THIS LINE **********/

	rprintf("Initialization Complete \r\n");

	//wait until user pushes button
	while(!button_pressed());

	reset_timer_0();
	reset_timer_2();

	while(1)
		{
		control();//use this for your code

		delay_cycles(100);//an optional small delay to prevent crazy oscillations
		}
	/*********ADD YOUR CODE ABOVE THIS LINE **********/

	return 0;
	}
